/*
 * The BackwardListIterator class steps through a /list object from the last element to the first
 * element.
 */

#if !defined(PIF_NOPREFIX_GENERAL) && !defined(PIF_NOPREFIX_ITERATOR)
pif_Iterator/BackwardListIterator
	parent_type = /pif_Iterator/ForwardListIterator
#else
Iterator/BackardListIterator
	parent_type = /Iterator/ForwardListIterator
#endif

	_Get(p)
		p = source.len - p + 1

		if((p < 1) || (p > source.len))
			return null
		else
			return source[p]

	/*
	 * Protocol implementation.
	 *
	 * Note: All other protocol methods are implemented in the ForwardListIterator superclass.
	 */

	New(list/_source)
		if(istype(_source))
			source = _source
		else
#if !defined(PIF_NOPREFIX_GENERAL) && !defined(PIF_NOPREFIX_ITERATOR)
			throw EXCEPTION("Expecting /list object for /pif_Iterator/BackwardListIterator constructor.")
#else
			throw EXCEPTION("Expecting /list object for /Iterator/BackwardListIterator constructor.")
#endif